/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania C - Stowka
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG
//#define VERBOSE

#include <stdio.h>
#include <assert.h>

#define MAXN 50000
#define MAXM 1000000000
#define MAXIMP 50
#define MAXLEN 100

struct NAME
{
  char fname[MAXLEN+1];
  char name[MAXLEN+1];
  char title[10];
} names[MAXN];
struct DATA
{
  int imp;
  int t0;
  int t1, t2;

  int n;
  int t;
  int out;
} data[MAXN];
int N;
int M;

int H[2][MAXN], HT[MAXN];
int hc[2], hcT;
int hn;

int T;


#define prior(v1, v2) ((data[v1].imp>data[v2].imp) || \
  ((data[v1].imp==data[v2].imp)&&(data[v1].n<=data[v2].n)))
#define priorT(v1, v2) ((data[v1].t<data[v2].t) || \
  ((data[v1].t==data[v2].t)&&(data[v1].n<=data[v2].n)))


void insert(int h, int v)
{
  int no, p;

  no = hc[h]++;
  while (no > 0)
  {
    p = (no-1)/2;
    if (prior(H[h][p], v))
      break;
    H[h][no] = H[h][p];
    no = p;
  }
  H[h][no] = v;
}
void insertT(int v)
{
  int no, p;

  no = hcT++;
  while (no > 0)
  {
    p = (no-1)/2;
    if (priorT(HT[p], v))
      break;
    HT[no] = HT[p];
    no = p;
  }
  HT[no] = v;
}

int delmin(int h)
{
  int no, s;
  int ret, v;

  ret = H[h][0];
  v = H[h][--hc[h]];
  no = 0;
  while (1)
  {
    s = 2*no+1;
    if (s >= hc[h])
      break;
    if ((s+1 < hc[h]) && prior(H[h][s+1], H[h][s]))
      s++;
    if (prior(v, H[h][s]))
      break;
    H[h][no] = H[h][s];
    no = s;
  }
  H[h][no] = v;
  return ret;
} 
int delminT()
{
  int no, s;
  int ret, v;

  ret = HT[0];
  v = HT[--hcT];
  no = 0;
  while (1)
  {
    s = 2*no+1;
    if (s >= hcT)
      break;
    if ((s+1 < hcT) && priorT(HT[s+1], HT[s]))
      s++;
    if (priorT(v, HT[s]))
      break;
    HT[no] = HT[s];
    no = s;
  }
  HT[no] = v;
  return ret;
} 

#define getmin(h) (H[h][0])
#define getminT (HT[0])
    

int main()
{
  int d;
  int n;
  int i;
  

  if (scanf("%d", &d) < 0)
    assert(0);
  assert(d > 0);

  while (d--)
  {
    if (scanf("%d%d", &N, &M) < 2)
      assert(0);
    assert((N > 0) && (N <= MAXN));
    assert((M > 0) && (M <= MAXM));

    for (i = 0; i < N; i++)
    {
      char str[MAXLEN+1];
      int imp;
      
      if (scanf("%s", str) < 1)
        assert(0);
      if ((str[0] < 'A') || (str[0] > 'Z'))
      {
        if (strcmp("mgr", str) == 0)
          data[i].imp = 100;
        else if (strcmp("dr", str) == 0)
          data[i].imp = 200;
        else if (strcmp("prof.", str) == 0)
          data[i].imp = 300;
        else
          assert(0);
        strcpy(names[i].title, str);
        if (scanf("%s", names[i].fname) < 1)
          assert(0);
      }
      else
      {
        data[i].imp = 0;
        strcpy(names[i].title, "");
        strcpy(names[i].fname, str);
      }
      if (scanf("%s", names[i].name) < 1)
        assert(0);;
#ifndef NDEBUG
      {
        int ll, ii;
        ll = strlen(names[i].name);
        assert((ll >= 2) && (ll <= MAXLEN));
        assert((names[i].name[0] >= 'A') && (names[i].name[0] <= 'Z'));
        for (ii = 1; ii < ll; ii++)
          assert((names[i].name[ii] >= 'a') && (names[i].name[ii] <= 'z'));
        ll = strlen(names[i].fname);
        assert((ll >= 2) && (ll <= MAXLEN));
        assert((names[i].fname[0] >= 'A') && (names[i].fname[0] <= 'Z'));
        for (ii = 1; ii < ll; ii++)
          assert((names[i].fname[ii] >= 'a') && (names[i].fname[ii] <= 'z'));
      }
#endif
      if (scanf("%d%d%d%d", &imp, &data[i].t0, &data[i].t1, &data[i].t2) < 4)
        assert(0);
      assert((data[i].t0 >= 0) && (data[i].t0 <= M));
      assert((data[i].t1 >= 0) && (data[i].t1 <= MAXM));
      assert((data[i].t2 >= 0) && (data[i].t2 <= MAXM));
      assert((data[i].t1 > 0) || (data[i].t2 > 0));
      assert((0 == i) || (data[i].t0 >= data[i-1].t0));
      assert((imp >= 0) && (imp <= MAXIMP));
      data[i].imp += imp;
      data[i].out = 0;
    }

    hc[0] = hc[1] = hcT = 0;
    hn = 0;
    T = 0;
    
    n = 0;
    while (T <= M)
    {
      int bempty;
      int v;
      int nT;

#ifdef VERBOSE
printf("time: %d\n", T);
#endif
      
      while ((hcT > 0) && (data[getminT].t == T))
      {
        v = delminT();
        data[v].n = hn++;
#ifdef VERBOSE
printf("%d entering Q2\n", v);
#endif
        insert(1, v);
      }
      while ((n < N) && (data[n].t0 == T))
      {
        if (0 != data[n].t1)
        {
#ifdef VERBOSE
printf("%d entering Q1\n", n);
#endif
          data[n].n = n;
          insert(0, n);
        }
        else
        {
#ifdef VERBOSE
printf("%d entering Q2 (directly)\n", n);
#endif
          data[n].n = hn++;
          insert(1, n);
        }
        n++;
      }

      bempty = 1;
      if (hc[0] > 0)
      {
        bempty = 0;
        v = delmin(0);
#ifdef VERBOSE
printf("%d leaving Q1\n", v);
#endif
        data[v].t = T+data[v].t1;
        if (data[v].t2 > 0)
          insertT(v);
        else
        {
#ifdef VERBOSE
printf("%d leaving cantine\n", v);
#endif
          data[v].out = 1;
        }
      }
      if (hc[1] > 0)
      {
        bempty = 0;
        v = delmin(1);
        data[v].t = T+data[v].t2;
        data[v].out = 1;
#ifdef VERBOSE
printf("%d leaving Q2 & cantine\n", v);
#endif
      }
      
      if (bempty)
      {
        nT = 2100000000;
        if (n < N)
          nT = data[n].t0;
        if ((hcT > 0) && (data[getminT].t < nT))
          nT = data[getminT].t;
        if (2100000000 == nT)
          break;
        assert(nT > T);
        T = nT;
      }
      else
        T++;
    }

#ifdef VERBOSE
printf("----------\n");
#endif
    for (i = 0; i < N; i++)
    {
      if (strcmp(names[i].title, "") != 0)
        printf("%s ", names[i].title);
      if ((!data[i].out) || (data[i].t > M))
        data[i].t = M;
      printf("%s %s %d\n", names[i].fname, names[i].name, data[i].t);
    }
#ifdef VERBOSE
printf("**********\n");
#endif
        
  }
  
  return 0;
}
