/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania E - Klucze
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#include <stdio.h>
#include <assert.h>

#define MAXN 10000
#define MAXM 100000


int LG[MAXM], LG2[MAXM];
int *G[MAXN], *G2[MAXN];
int gc[MAXN], gc2[MAXN];

int cnt;
int D[MAXN];
int C[MAXN];
int K[MAXN];
int L[MAXN];
int lp;


void DFSforw(int no)
{
  int i;

  assert((no >= 0) && (no < MAXN) && (0 == D[no]));
  D[no] = 1;
  for (i = 0; i < gc[no]; i++)
  {
    int v = G[no][i];
    assert((v >= 0 ) && (v < MAXN));
    if (!D[v])
      DFSforw(v);
  }

  L[--lp] = no;
}

void DFSback(int no, int col)
{
  int i;

  assert((no >= 0) && (no < MAXN) && (0 == D[no]));
  D[no] = 1;
  C[no] = col;
  for (i = 0; i < gc2[no]; i++)
  {
    int v = G2[no][i];
    assert((v >= 0 ) && (v < MAXN));
    if (!D[v])
      DFSback(v, col);
  }
}


void DFSfinal(int no)
{
  int i;

  assert((no >= 0) && (no < MAXN) && (0 == D[no]));
  
  D[no] = 1;
  for (i = 0; i < gc[no]; i++)
  {
    int v = G[no][i];
/*printf("TRYING %d->%d (%d)\n", no+1, v+1, D[v]);*/
    assert((v >= 0 ) && (v < MAXN));
    if (2 == D[v])
    {
      if ((C[v] != C[no]) && K[C[v]])
      {
        K[C[v]] = 0;
        cnt--;
      }
    }
    else if (0 == D[v])
    {
      DFSfinal(v);
    }
    else
    {
      assert(1 == D[v]);
    }
  }
  D[no] = 2;
}


int main()
{
  int d;
  int N;
  int i, j;
  

  if (scanf("%d", &d) < 1)
    assert(0);
  assert(d > 0);

  while (d--)
  {
    int sum;

    if (scanf("%d", &N) < 1)
      assert(0);
    assert((N > 0) && (N <= MAXN));

    for (i = 0; i < N; i++)
      gc2[i] = 0;
    sum = 0;
    for (i = 0; i < N; i++)
    {
      if (scanf("%d", &gc[i]) < 1)
        assert(0);
      assert((gc[i] >= 0) && (gc[i] <= MAXM));
      G[i] = LG+sum;
      sum += gc[i];
      assert((sum >= 0) && (sum <= MAXM));

      for (j = 0; j < gc[i]; j++)
      {
        if (scanf("%d", &G[i][j]) < 1)
          assert(0);
        assert((G[i][j] >= 1) && (G[i][j] <= N));
        G[i][j]--;
        gc2[G[i][j]]++;
      }
    }
    sum = 0;
    for (i = 0; i < N; i++)
    {
      G2[i] = LG2+sum;
      sum += gc2[i];
      assert((sum >= 0) && (sum <= MAXM));
      gc2[i] = 0;
    }
    for (i = 0; i < N; i++)
    {
      for (j = 0; j < gc[i]; j++)
      {
        int v = G[i][j];
        G2[v][gc2[v]++] = i;
      }
    }

    for (i = 0; i < N; i++)
      D[i] = 0;
    lp = N;
    for (i = 0; i < N; i++)
      if (0 == D[i])
        DFSforw(i);
    assert(0 == lp);
    for (i = 0; i < N; i++)
      D[i] = 0;
    for (i = 0; i < N; i++)
      if (0 == D[L[i]])
        DFSback(L[i], L[i]);


    for (i = 0; i < N; i++)
    {
      D[i] = 0;
      K[i] = 0;
    }
    cnt = 0;
    for (i = 0; i < N; i++)
    {
      if (0 == D[i])
      {
/*printf("ENTERING %d\n", i+1);*/
        cnt++;
        K[C[i]] = 1;
        DFSfinal(i);
      }
    }
#ifndef NDEBUG
    {
      int cc = 0;
      int ii;
      for (ii = 0; ii < N; ii++)
        if (K[ii])
          cc++;
      assert(cc == cnt);
    }
#endif
    printf("%d\n", cnt);
  }


  return 0;
}

