/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania G - Skapiec
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG

#include <stdio.h>
#include <assert.h>

#define MAXN 10000
#define MAXVAL 10000

#define INF 2000000000

#define dist(a, b) (((X[a]-X[b])*(X[a]-X[b]))+((Y[a]-Y[b])*(Y[a]-Y[b])))
#define scalar(a, b, c) (((X[a]-X[b])*(X[a]-X[c]))+((Y[a]-Y[b])*(Y[a]-Y[c])))
#define cos(s, d1, d2)((long double)(s)/(d1))*((long double)(s)/(d2))
#define sgn(s) ((s) < 0)? -1 : (((s) > 0) ? 1 : 0)


int N;
int X[MAXN], Y[MAXN];



int main()
{
  int d;
  int B, C;
  int distAB, distAC, distAi, distBC, distBi;
  int scalarC, scalari;
  long double cosC, cosi;
  int sgnC, sgni;
  int i;
  

  if (scanf("%d", &d) < 1)
    assert(0);
  while (d--)
  {
    if (scanf("%d", &N) < 1)
      assert(0);
    assert((N >= 3) && (N <= MAXN));
    for (i = 0; i < N; i++)
    {
      if (scanf("%d%d", &X[i], &Y[i]) < 2)
        assert(0);
      assert((X[i] <= MAXVAL) && (X[i] >= -MAXVAL));
      assert((Y[i] <= MAXVAL) && (Y[i] >= -MAXVAL));
    }

    B = 1;
    distAB = dist(0, B);
    for (i = 1; i < N; i++)
    {
      distAi = dist(0, i);
      if (distAi < distAB)
      {
        distAB = distAi;
        B = i;
      }
    }
    
    C = 1;
    if (C == B)
      C++;
    scalarC = scalar(C, B, 0);
    distAC = dist(C, 0);
    distBC = dist(C, B);
    sgnC = sgn(scalarC);
    cosC = cos(scalarC, distAC, distBC);
    i = 2;
    for (i = 1; i < N; i++)
    {
      if (i == B)
        continue;
      scalari = scalar(i, 0, B);
      distAi = dist(i, 0);
      distBi = dist(i, B);
      sgni = sgn(scalari);
      cosi = cos(scalari, distAi, distBi);
      if (sgni*cosi < sgnC*cosC)
      {
        C = i;
        cosC = cosi;
        sgnC = sgni;
      }
    }

    assert((B > 0) && (B < N));
    assert((C > 0) && (C < N));
    assert(B != C);
    printf("%d %d %d\n", 1, B+1, C+1);
  }
  
  return 0;
}
