/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania J - Prostokaty
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG
//#define VERBOSE

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>



#define MAX 100000
#define MAXPOW2 262144
#define MAXVAL 1000000000

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))


#define SCANF(sum) \
{\
  int ch;\
  int ok = 0;\
  int sgn = 1;\
\
  sum = 0;\
  while (1)\
  {\
    ch = getchar();\
    if (ch >= '0' && ch <= '9')\
    {\
      sum = sum * 10 + ch - '0';\
      ok = 1;\
    } else\
    {\
      if (ok)\
        break;\
      if ('-' == ch)\
      {\
        sgn = -1;\
        ok = 1;\
      }\
    }\
  }\
  sum *= sgn;\
}


struct POINT
{
  int x, y;
} pts[2*MAX], *ppts[2*MAX];
int pc;

struct SEGMENT
{
  int x1, x2;
  int y;
} segs[2*MAX];
int sc;

struct NODE
{
  int neg;
  int cnt;
  int w;
} T[2*MAXPOW2];
int N;
int pow2;



int pptscmp(const void *a, const void *b)
{
  struct POINT *ppt1 = *(struct POINT**)a, *ppt2 = *(struct POINT**)b;

  if (ppt1->x < ppt2->x) return -1;
  if (ppt1->x > ppt2->x) return 1;
  return 0;
}

int segcmp(const void *a, const void *b)
{
  struct SEGMENT seg1 = *(struct SEGMENT*)a, seg2 = *(struct SEGMENT*)b;

  if (seg1.y < seg2.y) return -1;
  if (seg1.y > seg2.y) return 1;
  return 0;
}


int PartitionPt(int midx, int l, int r)
{
  int i, j;

  i = l - 1;
  j = r + 1;
  while (1)
  {
    do j--; while (ppts[j]->x > midx);
    do i++; while (ppts[i]->x < midx);
    if (i < j)
    {
      struct POINT *t;
      t = ppts[i];
      ppts[i] = ppts[j];
      ppts[j] = t;
    } else
      return j;
  }
}
int PartitionSeg(int midy, int l, int r)
{
  int i, j;

  i = l - 1;
  j = r + 1;
  while (1)
  {
    do j--; while (segs[j].y > midy);
    do i++; while (segs[i].y < midy);
    if (i < j)
    {
      struct SEGMENT t;
      t = segs[i];
      segs[i] = segs[j];
      segs[j] = t;
    } else
      return j;
  }
}

void QSortPts(int l, int r)
{
  int m;
  if (l == r)
    return;
  m = PartitionPt(ppts[(l+r)/2]->x, l, r);
  assert((m < r) && (m >= l));
  QSortPts(l, m);
  QSortPts(m+1, r);
}
void QSortSegs(int l, int r)
{
  int m;
  if (l == r)
    return;
  m = PartitionSeg(segs[(l+r)/2].y, l, r);
  assert((m < r) && (m >= l));
  QSortSegs(l, m);
  QSortSegs(m+1, r);
}



int put(int no, int px1, int px2, int x1, int x2)
{
  int m;
  int d;

  if ((px1 == x1) && (px2 == x2))
  {
    T[no].neg = !T[no].neg;
    d = T[no].w-2*T[no].cnt;
    T[no].cnt = T[no].w-T[no].cnt;

#ifdef VERBOSE
printf("*<%d;%d> %d/%d (%d)\n", x1, x2, T[no].cnt, T[no].w, T[no].neg);
#endif
    return d;
  }
  
  d = 0;
  m = (x1+x2)/2;
  if (px1 < m)
  {
    d += put(2*no, px1, min(px2, m), x1, m);
  }
  if (px2 > m)
  {
    d += put(2*no+1, max(px1, m), px2, m, x2);
  }
  if (T[no].neg)
  {
    T[no].cnt -= d;
    return -d;
  }
  T[no].cnt += d;
#ifdef VERBOSE
printf("<%d;%d> %d/%d (%d)\n", x1, x2, T[no].cnt, T[no].w, T[no].neg);
#endif
  return d;
}


int main()
{
  int d;
  int i;
  long long sum;


#ifndef NDEBUG
  if (scanf("%d", &d) < 1)
    assert(0);
#else
  SCANF(d);
#endif

  assert(d > 0);

  while (d--)
  {
#ifndef NDEBUG
    if (scanf("%d", &N) < 1)
      assert(0);
#else
    SCANF(N);
#endif
    assert((N > 0) && (N <= MAX));
    pc = 0;
    for (i = 0; i < N; i++)
    {
      int x1, x2, y1, y2;
#ifndef NDEBUG
      if (scanf("%d%d%d%d", &x1, &y1, &x2, &y2) < 4)
        assert(0);
#else
      SCANF(x1);
      SCANF(y1);
      SCANF(x2);
      SCANF(y2);
#endif
      assert((x1 >= -MAXVAL) && (x1 <= MAXVAL));
      assert((x2 >= -MAXVAL) && (x2 <= MAXVAL));
      assert((y1 >= -MAXVAL) && (y1 <= MAXVAL));
      assert((y2 >= -MAXVAL) && (y2 <= MAXVAL));
      assert((x1 != x2) && (y1 != y2));

      pts[pc].x = x1;
      pts[pc].y = y1;
      ppts[pc] = &pts[pc];
      pc++;
      pts[pc].x = x2;
      pts[pc].y = y2;
      ppts[pc] = &pts[pc];
      pc++;
    }
//    qsort(ppts, pc, sizeof(struct POINT*), pptscmp);
    QSortPts(0, pc-1);

    pow2 = 1;
    while (pow2 < pc)
      pow2 *= 2;
    assert(pow2 <= MAXPOW2);

    for (i = 1; i < pc; i++)
    {
      T[pow2+i-1].neg = 0;
      T[pow2+i-1].cnt = 0;
      T[pow2+i-1].w = ppts[i]->x-ppts[i-1]->x;
      ppts[i-1]->x = i-1;
    }
    for (i--; i < pow2; i++)
    {
      T[pow2+i].neg = 0;
      T[pow2+i].cnt = 0;
      T[pow2+i].w = 0;
    }
    ppts[pc-1]->x = pc-1;
    for (i = pow2-1; i > 0; i--)
    {
      T[i].w = T[2*i].w+T[2*i+1].w;
      T[i].neg = 0;
      T[i].cnt = 0;
    }

    sc = 0;
    for (i = 0; i < N; i++)
    {
      int x1, y1, x2, y2, tx;
      x1 = pts[2*i].x;
      y1 = pts[2*i].y;
      x2 = pts[2*i+1].x;
      y2 = pts[2*i+1].y;
      if (x1 > x2)
      {
        tx = x1;
        x1 = x2;
        x2 = tx;
      }
      segs[sc].x1 = x1;
      segs[sc].x2 = x2;
      segs[sc].y = y1;
      sc++;
      segs[sc].x1 = x1;
      segs[sc].x2 = x2;
      segs[sc].y = y2;
      sc++;
    }
//    qsort(segs, sc, sizeof(struct SEGMENT), segcmp);
    QSortSegs(0, sc-1);

    sum = 0;
    for (i = 0; i < sc; i++)
    {
      if (i > 0)
        sum += (long long)T[1].cnt*(segs[i].y-segs[i-1].y);
#ifdef VERBOSE
printf("[%lld]\n", sum);
printf("Putting <%d;%d>\n", segs[i].x1, segs[i].x2);
#endif
      put(1, segs[i].x1, segs[i].x2, 0, pow2);
    }
    assert((0 == T[1].cnt) && (!T[1].neg));
    
    printf("%lld\n", sum);
  }
  
  return 0;
}
